# TerrainData

#### new Cesium.TerrainData()
Core/TerrainData.js 14

Terrain data for a single tile. This type describes an interface and is not intended to be instantiated directly.

##### See:

- HeightmapTerrainData
- QuantizedMeshTerrainData
- GoogleEarthEnterpriseTerrainData

### Members

#### credits : Array.<Credit>
Core/TerrainData.js 24

An array of credits for this tile.

#### waterMask : Uint8Array|HTMLImageElement|HTMLCanvasElement
Core/TerrainData.js 34

The water mask included in this terrain data, if any. A water mask is a rectangular Uint8Array or image where a value of 255 indicates water and a value of 0 indicates land. Values in between 0 and 255 are allowed as well to smoothly blend between land and water.

### Methods

#### interpolateHeight(rectangle, longitude, latitude) → Number
Core/TerrainData.js 50

Computes the terrain height at a specified longitude and latitude.

Name | Type | Description
--- | --- | ---
`rectangle` | Rectangle | The rectangle covered by this terrain data.
`longitude` | Number | The longitude in radians.
`latitude` | Number | The latitude in radians.

##### Returns:

The terrain height at the specified position. If the position is outside the rectangle, this method will extrapolate the height, which is likely to be wildly incorrect for positions far outside the rectangle.

#### isChildAvailable(thisX, thisY, childX, childY) → Boolean
Core/TerrainData.js 65

Determines if a given child tile is available, based on the `TerrainData#childTileMask`. The given child tile coordinates are assumed to be one of the four children of this tile. If non-child tile coordinates are given, the availability of the southeast child tile is returned.

Name | Type | Description
--- | --- | ---
`thisX` | Number | The tile X coordinate of this (the parent) tile.
`thisY` | Number | The tile Y coordinate of this (the parent) tile.
`childX` | Number | The tile X coordinate of the child tile to check for availability.
`childY` | Number | The tile Y coordinate of the child tile to check for availability.

##### Returns:

True if the child tile is available; otherwise, false.

#### upsample(tilingScheme, thisX, thisY, thisLevel, descendantX, descendantY, descendantLevel) → Promise.<TerrainData>|undefined
Core/TerrainData.js 102

Upsamples this terrain data for use by a descendant tile.

Name | Type | Description
--- | --- | ---
`tilingScheme` | TilingScheme | The tiling scheme of this terrain data.
`thisX` | Number | The X coordinate of this tile in the tiling scheme.
`thisY` | Number | The Y coordinate of this tile in the tiling scheme.
`thisLevel` | Number | The level of this tile in the tiling scheme.
`descendantX` | Number | The X coordinate within the tiling scheme of the descendant tile for which we are upsampling.
`descendantY` | Number | The Y coordinate within the tiling scheme of the descendant tile for which we are upsampling.
`descendantLevel` | Number | The level within the tiling scheme of the descendant tile for which we are upsampling.

##### Returns:

A promise for upsampled terrain data for the descendant tile, or undefined if too many asynchronous upsample operations are in progress and the request has been deferred.

#### wasCreatedByUpsampling() → Boolean
Core/TerrainData.js 113

Gets a value indicating whether or not this terrain data was created by upsampling lower resolution terrain data. If this value is false, the data was obtained from some other source, such as by downloading it from a remote server. This method should return true for instances returned from a call to `TerrainData#upsample`.

##### Returns:

True if this instance was created by upsampling; otherwise, false.